part of tecfy_core_client_package;

class ReportProperty {
  late String dbName;
  late ValueTypes type;

  late String nameAr;
  late String nameEn;
  String? format;
  late bool sortable;
  int sortId = 0;

  String? colorField;
  String? drillDownEntity;
  String? drillDownIdField;
  bool drillDownEntityDynamic = false;

  String? descriptionAr;
  String? descriptionEn;

  /// get the name according to login language
  String? get description => LocalConfigService.isArabic
      ? (descriptionAr ?? descriptionEn)
      : (descriptionEn ?? descriptionAr);

  /// get the name according to login language
  String get name => LocalConfigService.isArabic ? nameAr : nameEn;

  ReportProperty.fromMap(Map<String, dynamic> row) {
    dbName = lowerFirst(row['dbName']) ?? '';
    type = ValueTypes.values[row['type']];
    nameAr = row['nameAr'] ?? dbName;
    nameEn = row['nameEn'] ?? dbName;
    descriptionAr = row['descriptionAr'];
    descriptionEn = row['descriptionEn'];
    colorField = lowerFirst(row['colorField']);
    drillDownEntity = lowerFirst(row['drillDownEntity']);
    drillDownIdField = lowerFirst(row['drillDownIdField']);
    drillDownEntityDynamic = row['drillDownEntityDynamic'] ?? false;
    format = row['format'];
    if (format?.isEmpty ?? false) format = null;
    sortable = row['sortable'] ?? false;
    sortId = row['sortId'] ?? 0;
  }

  String? lowerFirst(String? s) {
    if (s == null || s.isEmpty) return '';
    return '${s[0].toLowerCase()}${s.substring(1)}';
  }

  String? upperFirst(String? s) {
    if (s == null || s.isEmpty) return '';
    return '${s[0].toUpperCase()}${s.substring(1)}';
  }
}
