part of tecfy_core_client_package;

class MapAreaPropertyComponenet extends StatefulWidget {
  /// init value
  final String? initalValue;

  /// label string
  final String? label;
  final String? description;

  /// is required
  final bool isRequired;

  /// filed id
  final String? fileId;

  /// on changed
  final void Function(String)? onChanged;
  MapAreaPropertyComponenet(
      {this.initalValue,
      this.label,
      this.description,
      this.isRequired = false,
      this.onChanged,
      this.fileId});
  @override
  _MapAreaPropertyComponenetState createState() =>
      _MapAreaPropertyComponenetState();
}

class _MapAreaPropertyComponenetState extends State<MapAreaPropertyComponenet> {
  GlobalKey _key = GlobalKey();
  // String _mapStyle;
  late List<LatLng> _points;
  bool _marking = false;
  @override
  initState() {
    print('------------------------------ ${widget.initalValue}');
    if (widget.initalValue == null || widget.initalValue!.isEmpty) {
      _points = [];
    } else {
      _points = json
          .decode(widget.initalValue!)
          .map<LatLng>((c) => LatLng(c[0], c[1]))
          .toList();
    }
    _init();
    super.initState();
  }

  _init() async {
    if (_points.length < 3) return;
    await Future.delayed(Duration(milliseconds: 50));
    // GoogleMap.of(_key).addPolygon('0', points,
    //     strokeColor: Colors.yellow,
    //     strokeOpacity: 1,
    //     strokeWidth: 2,
    //     fillColor: Colors.yellow,
    //     fillOpacity: 0.35);

    setState(() {});
  }

  _onChanged() {
    var r = json.encode(_points.map((e) => [e.latitude, e.longitude]).toList());
    widget.onChanged?.call(r);
  }

  @override
  Widget build(BuildContext context) {
    return Stack(
      children: [
        Container(
            child: GoogleMap(
              initialCameraPosition: CameraPosition(target: LatLng(0, 0)),
              key: _key,
              // initialZoom: 17.5,
              // initialPosition: points.length == 0
              //     ? GeoCoord(24.885449, 46.583643)
              //     : points.first,
              // mapType: MapType.hybrid,
              // mapStyle: _mapStyle,
              // interactive: true,
              onTap: (coord) {
                if (!_marking) return;
                _points.add(coord);
                // GoogleMap.of(_key).addMarker(Marker(coord));
                if (_points.length > 2) {
                  // GoogleMap.of(_key).clearPolygons();
                  // GoogleMap.of(_key).addPolygon('0', points,
                  //     strokeColor: Colors.yellow,
                  //     strokeOpacity: 1,
                  //     strokeWidth: 2,
                  //     fillColor: Colors.yellow,
                  //     fillOpacity: 0.35);

                  _onChanged();
                }
                //setState((){});
              },
              // =>
              //     _scaffoldKey.currentState.showSnackBar(SnackBar(
              //   content: Text(coord?.toString()),
              //   duration: const Duration(seconds: 2),
              // )),
            ),
            constraints: BoxConstraints(maxHeight: 500)),
        Align(
            alignment: Alignment.topRight,
            child: Padding(
                padding: EdgeInsets.all(5),
                child: Column(
                  children: [
                    CircleAvatar(
                        backgroundColor: ThemeService.mainColor,
                        child: IconButton(
                            icon: Icon(Icons.clear),
                            tooltip: 'Clear',
                            color: Colors.red,
                            onPressed: () {
                              _points = [];
                              // GoogleMap.of(_key).clearPolygons();
                              // GoogleMap.of(_key).clearMarkers();
                            })),
                    SizedBox(height: 5),
                    CircleAvatar(
                        backgroundColor: ThemeService.mainColor,
                        child: IconButton(
                            icon: Icon(_marking ? Icons.done : Icons.edit),
                            tooltip: _marking ? 'Done' : 'Start Marke',
                            color: _marking ? Colors.green : Colors.greenAccent,
                            onPressed: () {
                              setState(() {
                                _marking = !_marking;
                                if (_marking) {
                                  // for (var p in points)
                                  // GoogleMap.of(_key).addMarker(Marker(p));
                                } else {
                                  // GoogleMap.of(_key).clearMarkers();
                                }
                              });
                            })),
                  ],
                )))
      ],
    );
  }
}
